"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _index = require("../index");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _isIgnoredAttrPresent = function _isIgnoredAttrPresent(e, settings) {
  var element = e.currentTarget;
  var ignoreAttr = settings.ignoreEls;
  var elAttributes = element.attributes;

  for (var el in ignoreAttr) {
    var currentAttr = elAttributes.getNamedItem(el);
    if (currentAttr) {
      var regex = new RegExp(ignoreAttr[el]);
      return regex.test(currentAttr.value);
    }
  }
  return false;
};

var withRipple = function withRipple(Wcomp, GSetting) {
  return function (props) {
    var settings = {
      color: props.tmripple && props.tmripple.color || GSetting && GSetting.color || "rgba(255,255,255, 0.5)",
      eventName: props.tmripple && props.tmripple.eventName || GSetting && GSetting.eventName || "click",
      ignoreEls: GSetting && GSetting.ignoreEls || {},
      disabled: props.tmripple && props.tmripple.disabled || false
    };

    return _react2.default.createElement(Wcomp, _extends({}, props, {
      onClick: function onClick(e) {
        if (!settings.disabled && !_isIgnoredAttrPresent(e, settings)) {
          _index.ripple.call(undefined, e, settings.color, settings.eventName);
        }
        props.onClick && props.onClick.call(undefined, e);
      }
    }));
  };
};

exports.default = withRipple;
